net.sf.saxon.tree.iter

## Class TextLinesIterator

- java.lang.Object
- - net.sf.saxon.tree.iter.TextLinesIterator

- All Implemented Interfaces:
    SequenceIterator<StringValue>
  Direct Known Subclasses:
    UnparsedTextIterator

      public abstract class TextLinesIterator
      extends Object
      implements SequenceIterator<StringValue>

  An iterator that iterates over a file line by line. It is abstract because it does not supply the getAnother() method

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected NameChecker` | `checker`
    `protected SourceLocator` | `location`
    `protected LineNumberReader` | `reader`
    `protected URI` | `uri`

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `TextLinesIterator()`
    `` | `TextLinesIterator(LineNumberReader reader, SourceLocator location, URI uri, NameChecker checker)` Create a TextLinesIterator over a given reader

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the iterator.
    `StringValue` | `current()` The current line in the file
    `int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
    `StringValue` | `next()` Get the next item in the sequence.
    `int` | `position()` The line position currently being read

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `getAnother`

- - ### Field Detail

    - #### reader

          protected LineNumberReader reader

    - #### checker

          protected NameChecker checker

    - #### location

          protected SourceLocator location

    - #### uri

          protected URI uri

  - ### Constructor Detail

    - #### TextLinesIterator

          protected TextLinesIterator()

    - #### TextLinesIterator

          public TextLinesIterator(LineNumberReader reader,
                           SourceLocator location,
                           URI uri,
                           NameChecker checker)
                            throws XPathException

      Create a TextLinesIterator over a given reader
      Parameters:
        `reader` - the reader that reads the file
        `checker` - checks that the characters in the file are legal XML characters
        `location` - the location of the instruction being executed, for diagnostics
        `uri` - the URI of the file being read, for diagnostics
      Throws:
        `XPathException` - if a dynamic error occurs

  - ### Method Detail

    - #### next

          public StringValue next()
                           throws XPathException

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator, in particular it affects the result of subsequent calls of position() and current().
      Specified by:
        `next` in interface `SequenceIterator<StringValue>`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### current

          public StringValue current()

      The current line in the file
      Specified by:
        `current` in interface `SequenceIterator<StringValue>`
      Returns:
        returns StringValue: the current line in the file

    - #### position

          public int position()

      The line position currently being read
      Specified by:
        `position` in interface `SequenceIterator<StringValue>`
      Returns:
        returns the current line in the file

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `SequenceIterator<StringValue>`

    - #### getProperties

          public int getProperties()

      Description copied from interface: `SequenceIterator`
      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator<StringValue>`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.